-- Vorlesungsbeispiel, ALP1 
-- Author: Margarita Esponda

module BSTree where

data BSTree a = Nil | Node a (BSTree a) (BSTree a)
              deriving (Eq, Show)

mirror Nil = Nil
mirror (Node x leftTree rightTree) = Node x (mirror rightTree) (mirror leftTree)

biggest:: (Ord a) => BSTree a -> a
biggest t = smallest (mirror t)

depth::  BSTree a -> Int
depth Nil = 0
depth (Node x leftTree rightTree) = 1 + max (depth leftTree) (depth rightTree)

inOrder :: (Ord a) => BSTree a -> [a]
inOrder Nil = []
inOrder (Node x ltree rtree) = inOrder ltree ++ x: inOrder rtree

search:: (Ord a) => BSTree a -> a -> Bool
search Nil _  = False
search (Node k  lt rt)  x 
                       | k == x  = True
                       | x < k   = search lt x
                       | x > k   = search rt x

insert:: (Ord a) => BSTree a -> a -> BSTree a
insert Nil k  = Node k Nil Nil
insert (Node l  leftTree rightTree ) k
                                       |k <= l = (Node l  (insert leftTree k) rightTree)
                                       |otherwise = (Node l leftTree (insert rightTree k))

delete:: (Ord a) => a -> BSTree a -> BSTree a
delete x Nil = Nil
delete x (Node y ltree rtree)
                            | x< y = Node y (delete x ltree) rtree
                            | x==y = join ltree rtree
                            | x>y = Node y ltree (delete x rtree)
                 where
                 join:: (Ord a) => BSTree a -> BSTree a -> BSTree a
                 join xtree Nil = xtree
                 join xtree ytree = Node e xtree ntree
                                    where 
                                    (e, ntree) = splitMin ytree
                                    splitMin (Node k  Nil tree) = (k, tree)
                                    splitMin (Node k ltree rtree) = (f, Node k  ntree rtree)
                                                                    where 
                                                                    (f, ntree) = splitMin ltree

remove :: (Ord a) => a -> BSTree a -> BSTree a
remove x Nil = Nil
remove x (Node y ltree rtree)
                            | x< y = Node y (remove x ltree) rtree
                            | x==y = join ltree rtree
                            | x>y = Node y ltree (remove x rtree)
                   where
                   join :: (Ord a) => BSTree a -> BSTree a -> BSTree a
                   join xtree Nil = xtree
                   join xtree ytree = Node (smallest ytree) xtree (deleteMin ytree)



smallest:: (Ord a) => BSTree a -> a
smallest Nil = error "You entered an empty tree"
smallest (Node x Nil _) = x
smallest (Node x leftTree _ ) = smallest leftTree

deleteMin (Node k Nil tree) = tree
deleteMin (Node k ltree rtree) = Node k (deleteMin ltree) rtree

t5 = Node 5 (Node 3 (Node 2 Nil Nil) (Node 4 Nil Nil))
            (Node 8 (Node 6 Nil Nil) (Node 9 Nil Nil))

tw5 = Node (5,"cinco") (Node (3,"tres") (Node (2,"dos") Nil Nil) (Node (4,"cuatro") Nil Nil))
            (Node (8,"ocho") (Node (6,"seis") Nil Nil) (Node (9,"nueve") Nil Nil))

t6 = Node 5 (Node 3 (Node 2 Nil Nil) (Node 4 Nil Nil))
            (Node 8 (Node 6 Nil Nil) (Node 9 Nil (Node 10 Nil Nil)))


printBSTree tree = putStr ((print' "" tree) ++ "\n")
               where 
               print' node Nil = node ++ "Nil"
               print' node (Node x lt rt) = print' ('\t':node) rt ++ "\n" ++ node ++ 
                                                       show x ++ "\n" ++ 
                                            print' ('\t':node) lt 



